#include        "defs.h"

TASKDIALOGINDIRECT      g_TaskDialogIndirect = NULL;

BOOL WINAPI DllMain(
  __in  HINSTANCE hinstDLL,
  __in  DWORD fdwReason,
  __in  LPVOID lpvReserved
){
        WCHAR   wsProcessBaseName[MAX_PATH];
        WCHAR   wsEventName[MAX_PATH];
        ULONG_PTR       pTaskDialogIndirect;
        
        if (fdwReason != DLL_PROCESS_ATTACH) return TRUE;
        
        memset(wsProcessBaseName, 0, sizeof(wsProcessBaseName));
        GetModuleBaseName(GetCurrentProcess(), GetModuleHandle(0), wsProcessBaseName, MAX_PATH);
        if (_wcsicmp(wsProcessBaseName, L"explorer.exe")) return TRUE;
        //init hook
        StringCchPrintf(wsEventName, MAX_PATH, L"DisableFormatDriveNotification%.08X", GetCurrentProcessId());
        CreateEvent(NULL, FALSE, FALSE, wsEventName);
        
        pTaskDialogIndirect = (ULONG_PTR)GetProcAddress(LoadLibrary(L"comctl32.dll"), "TaskDialogIndirect");
        if (!pTaskDialogIndirect) return TRUE;
                
        HookLde((PVOID)pTaskDialogIndirect, (PVOID)HookTaskDialogIndirect, (PVOID *)&g_TaskDialogIndirect);
        
        return TRUE;
}


HRESULT WINAPI HookTaskDialogIndirect(
    TASKDIALOGCONFIG *pTaskConfig,
    int *pnButton,
    int *pnRadioButton,
    BOOL *pfVerificationFlagChecked
){
        size_t len;
        
        if (!pTaskConfig) goto __Exit0;        
        if ((ULONG_PTR)pTaskConfig->pszMainInstruction < 0x10000) goto __Exit0;
        
        StringCchLength(L"You need to format the disk in drive ", MAX_PATH, &len);
        if (_wcsnicmp(pTaskConfig->pszMainInstruction, L"You need to format the disk in drive ", len)) goto __Exit0;

        OutputDebugStringA("simulating IDCANCEL...\n");
        
        if (pnButton){
                *pnButton = IDCANCEL;
                return S_OK;
        }
        
        return E_FAIL;
__Exit0:
        return g_TaskDialogIndirect(pTaskConfig,
                                    pnButton,
                                    pnRadioButton,
                                    pfVerificationFlagChecked);
}


